<template>
  <div class="ele-body">
    <el-card shadow="never" v-loading="loading">
      <page-search-table @search="reload"></page-search-table>
      <!-- 数据表格 -->
      <ele-pro-table
        ref="table"
        :columns="columns"
        :datasource="datasource"
        height="calc(100vh - 325px)"
        full-height="calc(100vh - 116px)"
        tool-class="ele-toolbar-form"
        :selection.sync="selection"
        cache-key="eomContactPageTable"
      >
        <!-- 表头工具栏 -->
        <template v-slot:toolbar>
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="handleAddOrEdit('','add')"
          >
            新建
          </el-button>
          <el-button
            size="small"
            type="danger"
            el-icon-delete
            class="ele-btn-icon"
            @click="allDelBtn"
            :disabled="selection?.length === 0"
          >
            批量删除
          </el-button>
        </template>
        <!-- 操作 -->
        <template v-slot:action="{row}">
          <!--          <el-link-->
          <!--            type="primary"-->
          <!--            v-if="[0, 3].includes(row.approvalStatus)"-->
          <!--            :underline="false"-->
          <!--            icon="el-icon-plus"-->
          <!--            @click="sub(row)"-->
          <!--          >-->
          <!--            提交-->
          <!--          </el-link>-->
          <el-link
            type="primary"
            :underline="false"
            icon="el-icon-edit"
            @click="handleAddOrEdit(row,'update')"
          >
            修改
          </el-link>
          <el-popconfirm
            class="ele-action"
            title="确定要删除此信息吗？"
            @confirm="remove([row.id])"
          >
            <template v-slot:reference>
              <el-link
                type="danger"
                :underline="false"
                icon="el-icon-delete"
              >
                删除
              </el-link>
            </template>
          </el-popconfirm>
        </template>
        <template v-slot:driverName="{row}">
          <el-link
            type="primary"
            :underline="false"
            @click="handleDetail(row,'view')"
          >
            {{ row.driverName }}
          </el-link>
        </template>
<!--        <template v-slot:drivingLicenseType="{row}">-->
<!--          {{ getDict('驾照类型', row.drivingLicenseType) }}-->
<!--        </template>-->
      </ele-pro-table>

      <!-- 多选删除弹窗 -->
      <pop-modal
        :visible.sync="delVisible"
        content="是否确定删除？"
        @done="commitBtn"
      />
      <!--  新增/修改  -->
      <add-or-edit-dialog v-if="addOrEditDialogFlag" :addOrEditDialogFlag.sync="addOrEditDialogFlag"
                          ref="addOrEditDialogRef" @reload="reload"></add-or-edit-dialog>
      <detail-dialog v-if="detailDialogFlag" :detail-dialog-flag.sync="detailDialogFlag"
                     ref="detailDialogRef"></detail-dialog>
    </el-card>
  </div>

</template>

<script>
import popModal from '@/components/pop-modal';
import {reviewStatus} from '@/enum/dict';
import dictMixins from "@/mixins/dictMixins";
import pageSearchTable from "./indexSearchTable.vue";

import addOrEditDialog from './components/addOrEditDialog.vue'
import detailDialog from './components/detailDialog.vue'
import {driverBookPageListAPI, driverRemoveAPI, driverSubmit} from "@/api/transportManager/driverBook";
import {mapGetters} from "vuex";

export default {
  mixins: [dictMixins],
  components: {
    addOrEditDialog,
    pageSearchTable,
    popModal,
    detailDialog
  },
  data() {
    return {
      selection: [],
      statusList: [
        {
          label: '空闲',
          value: 0,
        },
        {
          label: '派单中',
          value: 1,
        }
      ],
      delVisible: false,
      // 加载状态
      loading: false,
      addOrEditDialogFlag: false,
      detailDialogFlag: false,
    };
  },
  computed: {
    ...mapGetters(['dict','getDictValue']),
    columns() {
      return [
        {
          width: 45,
          type: 'selection',
          columnKey: 'selection',
          align: 'center'
        },
        {
          columnKey: 'index',
          label: '序号',
          type: 'index',
          width: 55,
          align: 'center',
          showOverflowTooltip: true,
          fixed: 'left'
        },
        {
          prop: 'driverName',
          label: '姓名',
          align: 'center',
          showOverflowTooltip: true,
          minWidth: 120,
          slot: 'driverName'
        },
        {
          prop: 'sex',
          label: '性别',
          align: 'center',
          showOverflowTooltip: true,
          minWidth: 100,
          formatter: (_row, _column, cellValue) => {
            return cellValue == 1 ? '男' : cellValue == 2 ? '女' : '';
          }
        },
        {
          prop: 'age',
          label: '年龄',
          align: 'center',
          showOverflowTooltip: true,
          minWidth: 100
        },
        {
          prop: 'phone',
          label: '手机号',
          align: 'center',
          slot: 'phone',
          showOverflowTooltip: true,
          minWidth: 120,
        },
        {
          prop: 'personId',
          label: '身份证号',
          align: 'center',
          slot: 'personId',
          showOverflowTooltip: true,
          minWidth: 120,
        },
        {
          prop: 'driverAge',
          label: '驾龄',
          align: 'center',
          slot: 'driverAge',
          showOverflowTooltip: true,
          minWidth: 100,
        },
        {
          prop: 'drivingLicenseType',
          label: '驾驶证类型',
          align: 'center',
          slot: 'drivingLicenseType',
          showOverflowTooltip: true,
          formatter: (_row, _column, cellValue) => {
            return this.getDict('驾照类型', cellValue)
          },
          minWidth: 100,
        },
        {
          prop: 'status',
          label: '状态',
          align: 'center',
          slot: 'status',
          showOverflowTooltip: true,
          minWidth: 100,
          formatter: (_row, _column, cellValue) => {
            return this.statusList.find(i => i.value == cellValue)?.label;
          }
        },
        {
          columnKey: 'action',
          label: '操作',
          width: 150,
          align: 'center',
          resizable: false,
          slot: 'action',
          showOverflowTooltip: true,
          fixed: 'right'
        }
      ]
    },
    getDict() {
      return (dictName, val) => {
        return this.getDictValue(dictName, val)
      }
    }
  },
  methods: {
    //新增、修改
    handleAddOrEdit(row = {}, type) {
      this.addOrEditDialogFlag = true
      this.$nextTick(() => {
        this.$refs.addOrEditDialogRef.init(row, type)
      })
    },
    //详情
    handleDetail(row = {}, type) {
      this.detailDialogFlag = true
      this.$nextTick(() => {
        this.$refs.detailDialogRef.init(row, type)
      })
    },

    /* 表格数据源 */
    datasource({page, limit, where, order}) {
      return driverBookPageListAPI({
        pageNum: page,
        size: limit,
        ...where
      });
    },

    /* 刷新表格 */
    reload(where) {
      this.$nextTick(() => {
        this.$refs.table.reload({page: 1, where});
      })
    },

    //批量删除
    allDelBtn() {
      if (this.selection.length === 0) return;
      let flag = this.selection.some(item => [1, 2].includes(item.approvalStatus))
      if (flag) return this.$message.warning('抱歉已审核、审核中的数据不能删除,请检查')
      this.delVisible = true;
    },

    commitBtn() {
      const dataId = this.selection.map((v) => v.id);
      driverRemoveAPI(dataId).then((res) => {
        this.$message.success('删除成功！');
        this.reload();
      });
    },
    remove(row) {
      driverRemoveAPI(row).then((res) => {
        this.$message.success('删除成功！');
        this.reload();
      });
    },

    sub(res) {
      driverSubmit({
        businessId: res.id
      })
        .then((res) => {
          this.$message.success('提交成功');
          this.reload();
        })
        .catch((e) => {
          this.$message.error(e.message);
        });
    },
  }
};
</script>

<style lang="scss" scoped>
:deep(.el-link--inner) {
  margin-left: 0px !important;
}

.sys-organization-list {
  height: calc(100vh - 264px);
  box-sizing: border-box;
  border-width: 1px;
  border-style: solid;
  overflow: auto;
}

.sys-organization-list :deep(.el-tree-node__content) {
  height: 40px;

  & > .el-tree-node__expand-icon {
    margin-left: 10px;
  }
}
</style>
